/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include <stdlib.h>

#include "PerfectDfk31Au03Driver.h"
#include "Dfk31Au03Driver.h"
#include "Dfk31Au03Def.h"

namespace dfk41au03 {

/*
 * Constructor
 */
PerfectDfk31Au03Driver::PerfectDfk31Au03Driver(Dfk31Au03Driver* owner) :
		Dfk31Au03State(owner) {
	/* Empty */
}

/*
 * Destructor
 */
PerfectDfk31Au03Driver::~PerfectDfk31Au03Driver() {
	/* Empty */
}

void PerfectDfk31Au03Driver::init() {
}

/*
 * clearvme/daugther/Dfk31Au03
 */
void PerfectDfk31Au03Driver::clear() {
	// Read command

}

/*
 * writeParam
 */
void PerfectDfk31Au03Driver::writeParam() {
}

/*
 * synchroniseRead
 */
void PerfectDfk31Au03Driver::synchroniseRead() {
	read();
	owner()->m_SynchroniseReadTerminated = true;
}

/*
 * read
 */
void PerfectDfk31Au03Driver::read() {
	// Read command

	int32 sum = 0;
	//  if (m_FirstRead) {
	//    for (uint32 i=0;i<size;i++) {
	//      tab[i] = i + 1;
	//      sum = sum + tab[i];
	//    }
	//    m_FirstRead = false;
	//  } else {
	//    for (uint32 i=0;i<size;i++) {
	//      tab[i] = tab[i] + 1;
	//      sum = sum + tab[i];
	//    }
	//  }

}

/*
 * pause 
 */
void PerfectDfk31Au03Driver::pause() {
}

/*
 * continue 
 */
void PerfectDfk31Au03Driver::resume() {
}

/*
 * start
 */
void PerfectDfk31Au03Driver::start() {
}

/*
 * stop
 */
void PerfectDfk31Au03Driver::stop() {
}

/*
 * readStatus
 */
void PerfectDfk31Au03Driver::readStatus() {
	owner()->startActivated = false;
	// Status command
	owner()->computeAcquisitionStatus(0);
	owner()->computeDetectorStatus(0);
	if (owner()->m_SynchroniseReadActivated == true) {
		if (owner()->m_SynchroniseReadTerminated == true) {
			owner()->m_SynchroniseReadActivated = false;
			owner()->m_SynchroniseReadTerminated = false;
			owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
		}
	} else {
		owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
	}
}

/*
 * readInfos
 */
void PerfectDfk31Au03Driver::readInfos() {
}

}
